from kivymd.app import MDApp
from kivy.uix.screenmanager import ScreenManager, Screen
from kivy.clock import Clock, mainthread
from plyer import filechooser
from kivy.lang import Builder
from kivy.properties import ListProperty
import os
os.environ["IMAGEIO_FFMPEG_EXE"] = "/usr/bin/ffmpeg"
from kivy import platform
from kivy.storage.jsonstore import JsonStore
from kivy.properties import ObjectProperty
from datetime import datetime
from datetime import timedelta
from kivy.uix.gridlayout import GridLayout
from kivy.uix.popup import Popup
from kivy.uix.label import Label
from os import listdir
from os.path import isfile, join

USERPATH = os.path.expanduser("~")
class MyWidget(Screen):
       pass

class MainWindow(Screen):
    pass

class Selectmain(Screen):
    stored_data = ObjectProperty(None)

    def __init__(self, *args, **kwargs):
        super(Selectmain, self).__init__(*args, **kwargs)
        self.stored_data = JsonStore('data.json')

    def selected(self, filename):
        print(filename[0])
        self.ids.result.text = filename[0]

class Milk_Shake(Screen):
#self.parent is the equivalent to app.root
    def switch(self, *args):
        self.parent.current = "screen_1"

    def on_enter(self, *args):
        # called when this Screen is displayed
        Clock.schedule_once(self.switch, 20)

class Thick_Shake(Screen):
#self.parent is the equivalent to app.root
    def switch(self, *args):
        self.parent.current = "screen_1"

    def on_enter(self, *args):
        # called when this Screen is displayed
        Clock.schedule_once(self.switch, 20)

class SecondWindow(Screen):
    stored_data = ObjectProperty(None)
    stored_data1 = ObjectProperty(None)
    stored_data2 = ObjectProperty(None)

    def __init__(self, *args, **kwargs):

        super(SecondWindow, self).__init__(*args, **kwargs)

        self.stored_data = JsonStore('data.json')
        self.stored_data1 = JsonStore('data1.json')
        self.stored_data2 = JsonStore('data2.json')

class Merge(Screen):
    def selected(self, filename):
        print(filename[0])
        self.ids.result.text = filename[0]

class ErrorWindow(Screen):
    pass



class WindowManager(ScreenManager):
    pass


if platform == 'android':
    from android.permissions import request_permissions, Permission
    request_permissions([
        Permission.WRITE_EXTERNAL_STORAGE,
        Permission.READ_EXTERNAL_STORAGE,
        Permission.INTERNET,
    ])

class WidgetsApp(MDApp):
    selection = ListProperty([])
    selection_1 = ListProperty([])
    selection_2 = ListProperty([])
    selection_3 = ListProperty([])
    selection_4 = ListProperty([])
    selection_5 = ListProperty([])
    stored_data = ObjectProperty(None)

    def __init__(self, **kwargs):
        super().__init__(**kwargs)
        self.client = None
        self.temperature_node = None
        self.connected = False
        layout = GridLayout(cols=1, padding=10)

        popupLabel = Label(text="please connect plc")

        layout.add_widget(popupLabel)

        # Instantiate the modal popup and display
        self.popup = Popup( title='Fault Popup',
                      content=layout,
                      size_hint=(None, None), size=(400, 400))


    def build(self,  **kwargs):
        self.connected = False
        self.icon = "Dynaspede Logo small.jpg"
        self.theme_cls.theme_style = "Dark"
        self.theme_cls.primary_palette = "Blue"
        self.now = datetime.now()

        # Schedule the self.update_clock function to be called once a second
        Clock.schedule_interval(self.update_clock, 1)
        Clock.schedule_interval(self.Start, 1)
        Clock.schedule_interval(self.mainscreen, 1)

        #self.root.get_screen("main").ids.time.text = self.now.strftime('%H:%M:%S')
        return Builder.load_file('main19-4-2023.kv')

    def on_start(self, **kwargs):

        if platform == "android":
            from android.permissions import request_permissions, Permission
            request_permissions([Permission.WRITE_EXTERNAL_STORAGE, Permission.READ_EXTERNAL_STORAGE])

    def update_clock(self, *args):
        # Called once a second using the kivy.clock module
        # Add one second to the current time and display it on the label
        self.now = self.now + timedelta(seconds=1)
        self.root.get_screen("main").ids.time.text = self.now.strftime('%I:%M:%S')
        self.root.get_screen("main").ids.date.text = self.now.strftime(' %d-%b-%Y-%a')

    def choose(self):
        filechooser.open_file(on_selection=self.handle_selection)

    def handle_selection(self, selection):
        self.selection = selection

    @mainthread
    def on_selection(self,  **kwargs):
        self.video_folder_path = self.root.get_screen("selectmain").ids.result.text
        self.video_files = self.get_video_files_in_folder(self.video_folder_path)
        print(self.video_files)
        self.current_video_index = 0
        self.play_video(self.current_video_index)
        Clock.schedule_interval(self.update_video, 1 / 30)
        #self.root.get_screen("second").ids.result.text = self.selection[0]
        #self.root.get_screen("screen_1").ids.video_tape.source = self.root.get_screen("second").ids.result.text
        #App.get_running_app().root.ids.result.text = self.selection[0]
        #App.get_running_app().root.ids.video_tape.source = self.selection[0]

    def get_video_files_in_folder(self, folder_path):
        files = [f for f in listdir(folder_path) if isfile(join(folder_path, f))]
        return [f for f in files if f.endswith('.mp4') or f.endswith('.avi') or f.endswith('.mov') or f.endswith('.mpeg')]

    def play_video(self, video_index):
        self.root.get_screen("screen_1").ids.video_tape.source = str(self.video_folder_path + '/' + self.video_files[video_index])
        print(self.root.get_screen("screen_1").ids.video_tape.source)
        self.root.get_screen("screen_1").ids.video_tape.state = 'play'

    def update_video(self, dt):
        if self.root.get_screen("screen_1").ids.video_tape.state == 'stop':
            self.current_video_index += 1
            if self.current_video_index >= len(self.video_files):
                self.current_video_index = 0
            self.play_video(self.current_video_index)

    def choose_1(self):
        filechooser.open_file(on_selection=self.handle_selection_1)

    @mainthread
    def handle_selection_1(self, selection_1):
        self.selection_1 = selection_1
        self.root.get_screen("second").ids.result_1.text = self.selection_1[0]
        self.root.get_screen("screen_2").ids.video_tape_2.source = str(self.root.get_screen("second").ids.result_1.text)


    def choose_2(self):
        filechooser.open_file(on_selection=self.handle_selection_2)

    @mainthread
    def handle_selection_2(self, selection_2):
        self.selection_2 = selection_2
        self.root.get_screen("second").ids.result_2.text = self.selection_2[0]
        self.root.get_screen("screen_3").ids.video_tape_3.source = str(self.root.get_screen("second").ids.result_2.text)


    @mainthread
    def Start(self, *args):

        #self.root.get_screen("screen_1").ids.video_tape.source = self.root.get_screen("second").ids.result.text
        self.root.get_screen("screen_2").ids.video_tape_2.source = str(self.root.get_screen("second").ids.result_1.text)
        self.root.get_screen("screen_3").ids.video_tape_3.source = str(self.root.get_screen("second").ids.result_2.text)

    @mainthread
    def path_3(self):
        self.root.get_screen("merge").ids.filechooser.path = USERPATH

    def milkshake_click(self):
        self.root.get_screen("screen_1").ids.video_tape.state = "pause"
        self.root.get_screen("screen_2").ids.video_tape_2.state = "play"
        self.root.get_screen("screen_3").ids.video_tape_3.state = "stop"

    def thickshake_click(self):
        self.root.get_screen("screen_1").ids.video_tape.state = "pause"
        self.root.get_screen("screen_2").ids.video_tape_2.state = "stop"
        self.root.get_screen("screen_3").ids.video_tape_3.state = "play"

    def mainscreen(self, *args):
        if self.root.current_screen.name == 'screen_1':
            self.root.get_screen("screen_1").ids.video_tape.state = "play"
            self.root.get_screen("screen_2").ids.video_tape_2.state = "stop"
            self.root.get_screen("screen_3").ids.video_tape_3.state = "stop"


if __name__ == '__main__':
    window = WidgetsApp()
    window.run()
